/* ====================================================================
 *  Copyright 2004 Edward Rudd and Paul Querna
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *
 */

/**
 * svn streams for apr_brigades.  I guess no one has written this yet.
 */

#include "svn_stream_apr_brigade.h"

struct baton_brigade {
  apr_bucket_brigade *bb;
  apr_pool_t *pool;
};

static svn_error_t *
read_handler_brigade (void *baton, char *buffer, apr_size_t *len)
{

  return SVN_NO_ERROR;
}


static svn_error_t *
write_handler_brigade (void *baton, const char *data, apr_size_t *len)
{
  struct baton_brigade *btn = baton;

  apr_bucket *b = apr_bucket_heap_create(data, *len, NULL, btn->bb->bucket_alloc);
  if(b == NULL) {
    return svn_error_create(APR_ENOMEM, NULL, "Unable to create Heap Bucket");
  }
  else {
    APR_BRIGADE_INSERT_TAIL(btn->bb, b);
    return SVN_NO_ERROR;    
  }
}


svn_stream_t *svn_stream_from_aprbrigade (apr_bucket_brigade *bb, apr_pool_t *pool) 
{
  struct baton_brigade *baton;
  svn_stream_t *stream;

  if (bb == NULL)
    return svn_stream_empty(pool);

  baton = apr_palloc (pool, sizeof (*baton));
  baton->bb = bb;
  baton->pool = pool;
  stream = svn_stream_create (baton, pool);
  svn_stream_set_read (stream, read_handler_brigade);
  svn_stream_set_write (stream, write_handler_brigade);
  return stream;
}

